// Generated by dts-bundle-generator v8.1.2

import { ChangeEvent, Dispatch, FormEvent, PropsWithChildren, SetStateAction } from 'react';

export type SchemaValidationTypeString = {
	type: "string";
	required?: boolean;
	minLength?: number;
	maxLength?: number;
	pattern?: string;
};
export type SchemaValidationTypeNumber = {
	type: "number";
	required?: boolean;
	minimum?: number;
	maximum?: number;
};
export type SchemaValidationTypeArray = {
	type: "array";
	required?: boolean;
	minItems?: number;
	maxItems?: number;
	uniqueItems?: boolean;
	schema: Record<string, SchemaValidationType>;
};
export type SchemaValidationTypeObject = {
	type: "object";
	required?: boolean;
	properties: Record<string, SchemaValidationType>;
};
export type SchemaValidationType = SchemaValidationTypeString | SchemaValidationTypeNumber | SchemaValidationTypeArray | SchemaValidationTypeObject;
export interface useFormProps<DataType> {
	defaultValues?: Partial<DataType>;
	onSubmit: (data: DataType) => void;
	schema: Record<string, SchemaValidationType>;
	name?: string;
}
export type useFormReturnType<DataType> = {
	reset: (data?: DataType) => void;
	handleSubmit: (event: FormEvent<HTMLFormElement>) => void;
	errors: Record<string, string> | undefined;
};
export declare const useForm: <DataType extends object>({ schema, defaultValues, onSubmit, }: useFormProps<DataType>) => useFormReturnType<DataType>;
export type DataTypeSingle = string | boolean | number | [
	unknown
] | Record<string, unknown> | undefined;
export type DefaultFieldType = {
	name: string;
};
export type TextFieldType = DefaultFieldType & {
	type: "text";
	name: string;
};
export type FieldType = TextFieldType;
export interface useFieldProps {
	name: string;
}
export type useFieldReturnType<DataType> = {
	value: DataType | undefined;
	reset: (value?: DataType) => void;
	clean: () => void;
	name: string;
	onChange: (event: ChangeEvent<HTMLInputElement>) => void;
	error: string;
};
export declare const useField: <DataType extends DataTypeSingle>({ name, }: useFieldProps) => useFieldReturnType<DataType>;
export interface useFieldsProps {
	name: string;
	fieldArray: Array<FieldType>;
}
export type useFieldsReturnType = {
	fields: Array<Array<{
		value: DataTypeSingle | undefined;
		reset: (value?: DataTypeSingle) => void;
		clean: () => void;
		name: string;
		onChange: (event: ChangeEvent<HTMLInputElement>) => void;
		type: "text";
	}>>;
	append: () => void;
};
export declare const useFields: <DataType extends DataTypeSingle>({ name, fieldArray: fieldArrayRaw, }: useFieldsProps) => useFieldsReturnType;
export type FormContextType = {
	data: object;
	updateField?: (field: string, value: unknown) => void;
	getFieldValue: (field: string) => DataTypeSingle;
	getData: () => object;
	setData?: Dispatch<SetStateAction<object>>;
	errors: Record<string, string>;
	setErrors?: Dispatch<SetStateAction<Record<string, string>>>;
	getError: (field: string) => string;
};
export interface FormProviderProps<DataType> extends PropsWithChildren {
	defaultValues?: Partial<DataType>;
}
export declare const FormProvider: <DataType extends object>({ children, defaultValues, }: FormProviderProps<DataType>) => import("react/jsx-runtime").JSX.Element;

export {};
